unit F_Convert;

interface

{$IFDEF FPC}
{$Mode Delphi}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

uses
{$IFDEF FPC}
  EditBtn,
{$ELSE}
  Mask, rxToolEdit,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, FileCtrl,
  ExtCtrls, U_OnFormInfoIni, u_extdbgrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    ch_utf8: TCheckBox;
    DirectoryEdit: TDirectoryEdit;
    OnFormInfoIni: TOnFormInfoIni;
    Panel1: TPanel;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    Panel2: TPanel;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
  private
    procedure ConvertirDir(const as_Directory: String);
    procedure ConvertitField(var as_Ligne: String; const ai_LengthBegin: Integer
      );
    procedure ConvertitLigneDFMPAS(var as_Ligne: String);
    procedure ConvertitLigneLFM(const ast_Lignes: TStringList);
    procedure DeleteUntilEnd(const ast_Lignes: TStringList ; const ai_pos1, ai_posEnd : LongInt );
    procedure p_setLignes(const ast_lignes: TStringlist ;const FilePath : String);
    { Dclarations prives }
  public
    procedure ConvertitLignePAS( var ast_Lignes : TStringList; as_Lignes : String ); virtual;
    procedure ConvertitLigneDFM( var ast_Lignes : TStringList; as_Lignes : String ); virtual;
    procedure ConvertitFichier ( const FilePath, FileName  : String );
    { Dclarations publiques }
  end;
var
  Form1: TForm1;

implementation

uses StrUtils, fonctions_file,LConvEncoding;

var gb_Posifndef_fpc : Boolean = False ;
    gb_report        : Boolean = False ;

procedure TForm1.ConvertirClick(Sender: TObject);
var ls_Directory : String;
begin
  Messages.Lines.Clear;
  ls_Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF};
  ConvertirDir ( DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} );
  Messages.Lines.Add( '-> Tout est fini .' );
end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TForm1.ConvertirDir(const as_Directory : String );
var li_i : Integer ;
    lstl_StringList : TStringList;
begin
  lstl_StringList := TStringList.Create;
  Messages.Lines.Add( '-> Parcours de ' + as_Directory );
  if fb_FindFiles ( lstl_StringList, as_Directory, True, True, True ) Then
    Begin
      for li_i := 0 to lstl_StringList.Count - 1 do
        if (Directoryexists ( lstl_StringList [ li_i ] )) then
          Begin
            ConvertirDir(lstl_StringList [ li_i ] );
          End
         else
           if (Fileexists ( lstl_StringList [ li_i ] )) then
            Begin
              ConvertitFichier ( lstl_StringList [ li_i ], ExtractFileName ( lstl_StringList [ li_i ] ));
            End;

    End;
  Messages.Lines.Add( '-> Fin pour ' + as_Directory + '.' );
  lstl_StringList.free;
end;

procedure TForm1.ConvertitField( var as_Ligne : String ; const ai_LengthBegin : Integer );
var li_i, li_2Maj : Integer ;
    lb_Maj, lb_Maj2 : Boolean ;
begin
  lb_Maj  := False ;
  lb_Maj2 := False ;
  li_2Maj := 0;
  for li_i := ai_LengthBegin to length ( as_Ligne ) do
    Begin
      if ( as_Ligne [ li_i ] = '.' ) Then
        Begin
          if lb_Maj2 Then
            as_Ligne := copy(as_Ligne, 1, li_2Maj-1) +
                        '.FieldByName(''' +
                        copy(as_Ligne, li_2Maj, li_i -li_2Maj) +
                        ''')' +
                        copy(as_Ligne, li_i, length ( as_Ligne ) - li_i +1) ;
          Exit;
        end;
      if ( as_Ligne [ li_i ] in ['A'..'Z','_'] ) Then
        Begin
          if lb_Maj Then
            Begin
              if not lb_Maj2 Then
                li_2Maj := li_i - 1;
              lb_Maj2 := True;
            end;
          lb_Maj := True;
        end
       Else
        if as_Ligne [ li_i ] <> ' ' Then
          Begin
            lb_Maj  := False ;
            lb_Maj2 := False ;
          end;
    end;
End;

procedure p_ReplaceButton ( var as_Ligne : String ; const as_replaceEnd : String );
Begin
  as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFW'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatSpeedButton', 'TFS'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatButton', 'TFB'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TBlueFlatSpeedButton', 'TBFS'+as_replaceEnd, [rfIgnoreCase] );
end;

procedure TForm1.ConvertitLigneDFMPAS( var as_Ligne : String );
begin

  if ( pos ( 'ferme', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'close', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Close');

  if ( pos ( 'btndel', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'supp', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'delete', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'MDelete');
 
  if ( pos ( 'btnadd', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'ajout' , lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'MAdd');

  if ( pos ( 'categ', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'MFolder');

  if ( pos ( 'quit', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Quit');

  if ( pos ( 'prec' , lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'prior', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Prior');
 
  if ( pos ( 'suiv' , lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'next', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Next');

  if ( pos ( 'import', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Import');

  if ( pos ( 'export', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Export');

  if ( pos ( 'copie', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Copy');

  if ( pos ( 'aperc', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'previo' , lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Preview');

  if ( pos ( 'enreg', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'select', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'appliq', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'ok' , lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'OK');

  if ( pos ( 'init', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Init');

  if ( pos ( 'config', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Config');

  if ( pos ( 'inser', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Insert');

  if ( pos ( 'annul', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'cancel', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Cancel');

  if ( pos ( 'imprim', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'print', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Print');
  as_Ligne := StringReplace( as_Ligne, 'DataBinding.FieldName', 'FieldName', [] );
  as_Ligne := StringReplace( as_Ligne, 'DataBinding.DataSource', 'DataSource', [] );
  as_Ligne := StringReplace( as_Ligne, 'Style.Color', 'Color', [] );

  as_Ligne := StringReplace( as_Ligne, 'Properties.FieldName', 'FieldName', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.KeyFieldNames', 'LookupField', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.DropDownRows', 'DropDownCount', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.ListSource', 'LookupSource', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.Grid.DataController.Values', 'KeyValue', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.ReadOnly', 'ReadOnly', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.OnChange', 'OnChange', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.OnFocus', 'OnFocus', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.OnClick', 'OnClick', [] );
  if gb_report Then
    Begin
      as_Ligne := StringReplace( as_Ligne, 'UserName', 'FriendlyName', [rfReplaceAll,rfIgnoreCase] );
      as_Ligne := StringReplace( as_Ligne, 'Border.Color', 'Borders.Color', [rfReplaceAll,rfIgnoreCase] );
      as_Ligne := StringReplace( as_Ligne, 'Border.Style', 'Borders.Style', [rfReplaceAll,rfIgnoreCase] );
    end;
end;

procedure TForm1.p_setLignes ( const ast_lignes : TStringlist ;const FilePath : String );
var li_pos4, li_pos5 : LongInt ;
    ls_ligne : String ;
Begin
  ast_Lignes.Text := AnsiToUtf8 ( ast_Lignes.Text);
 { if pos ( '''#', ast_lignes.Text ) > 0 Then
    Begin
      ls_ligne:=ast_lignes.Text;
      li_pos4 := 1;
      while ( posex ( '''#', ls_Ligne, li_pos4 ) > 0 ) do
        Begin
          li_pos4 := posex ( '''#', ls_Ligne, li_pos4 );
          li_pos5 :=  posex ( '''', ls_Ligne, li_pos4 +1 );
          if li_pos5 - li_pos4 > 6 Then
            li_pos5 :=  posex ( '#', ls_Ligne, li_pos4 +1 );
          if  ( li_pos5 - li_pos4 < 7 )
          and ( li_pos5 - li_pos4 > 2 )
          and ( copy ( ls_Ligne, li_pos4 + 2, li_pos5 - li_pos4 - 2 ) [1] in ['0'..'9'] )
           Then
            try
  //            ShowMessage(copy ( ls_Ligne, li_pos4, li_pos5 - li_pos4 ) + ' : ' + copy ( ls_Ligne, li_pos4 + 2, li_pos5 - li_pos4 - 2));
              ls_Ligne := copy ( ls_Ligne, 1, li_pos4 - 1 )
                       + chr ( StrToInt( copy ( ls_Ligne, li_pos4 + 2, li_pos5 - li_pos4 - 2)))
                       + copy ( ls_Ligne, li_pos5 +1, Length( ls_Ligne ) - li_pos5 - 1 );

            Except
            end;
          inc ( li_pos4 );
        end;
      ast_Lignes.Text := ls_Ligne;
    end;   /}
  ConvertitLigneLFM ( ast_Lignes );
  ast_Lignes.SaveToFile   ( copy ( FilePath, 1, length ( filepath ) - 3 ) + 'lfm');

end;



procedure TForm1.ConvertitFichier(const FilePath, FileName : String);
var ls_Lignes : WideString ;
    lb_DFM ,
    lb_LFM ,
    lb_Pas ,
    lb_dpr : Boolean ;
    lst_Lignes : TStringList ;
begin
  lb_DFM := PosEx ( '.dfm', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lb_LFM := PosEx ( '.lfm', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lb_pas := PosEx ( '.pas', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lb_dpr := PosEx ( '.dpr', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lst_Lignes := TStringList.Create;
  if ( lb_DFM or lb_Pas or lb_LFM or lb_dpr ) then
    try
     if ch_utf8.Checked Then
       Begin
         lst_Lignes.LoadFromFile ( FilePath );
         lst_Lignes.text := ISO_8859_1ToUTF8(lst_Lignes.Text);
         lst_Lignes.SaveToFile   ( FilePath );
       end;
      lst_Lignes.LoadFromFile ( FilePath );
      ls_Lignes := lst_Lignes.Text;

      Application.ProcessMessages;

      gb_report := pos ( 'Tpp', ls_lignes ) > 0 ;
      if lb_dpr Then
        Begin
          ls_Lignes := StringReplace ( ls_Lignes, 'IBSQL in ''IBSQL.pas'',', '', [rfReplaceAll,rfIgnoreCase] );
        end
       else
        Begin
          ls_Lignes := StringReplace ( ls_Lignes, 'IBScript', 'IBQuery', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'www.ancestrologie.com', 'www.ancestromania.com', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'ancestrologie.com', 'ancestromania.com', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Ancestrologie', 'Ancestromania', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Auteur:  ', 'Auteurs :', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Auteur : ', 'Auteurs :', [rfReplaceAll,rfIgnoreCase] );
          gb_Posifndef_fpc := pos ( 'IFNDEF FPC', ls_Lignes ) > 0;
          if pos ( 'Andr Langlet', ls_Lignes ) = 0 Then
            ls_Lignes := StringReplace ( ls_Lignes, 'Philippe Cazaux-Moutou           ', 'Andr Langlet (Main), Matthieu Giroux (LAZARUS),            }'+#13#10+'{           Philippe Cazaux-Moutou (Old Ancestro GPL)', [rfReplaceAll,rfIgnoreCase] );

//          ls_Lignes := StringReplace ( ls_Lignes, 'Windows,', 'LCLType,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'registry,', 'fonctions_init,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TRegIniFile', 'TIniFile', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TIniFile.create', 'f_GetMemIniFile', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TRbSplitter', 'TSplitter', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'u_common_func,', 'u_common_functions,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinPopupMenu', 'TJvPopupMenu', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinTextLabel', 'TFWLabel', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxLabel', 'TFWLabel', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxLabel,', 'u_framework_components,u_common_ancestro,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxLabel', 'TFWLabel', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDateEdit', 'TRxDateEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TspDynamicSkinForm', 'TSmoothShow', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinButton', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxButton', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxComboBox', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCheckBox', 'TJvXPCheckBox', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxCheckBox,', 'JvXPCheckCtrls,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinButton', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TspGraphicEdit', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxGraphicEdit', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxGridReportLink', 'TRLDetailGrid', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinSpeedButton', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'OnCustomDrawCell', 'AfterCellPaint', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Position.ColIndex', 'Position', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Title.Caption.Text', 'Text', [rfReplaceAll,rfIgnoreCase] );


          ls_Lignes := StringReplace ( ls_Lignes, 'TdxStatusBar', 'TStatusBar', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TRbPanel', 'TPanel', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBButtonEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TDateTimePicker', 'TZVDateTimePicker', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBPopupEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxButtonEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxMRUEdit', 'TFWEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxEdit,', 'u_framework_components,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBPopupEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxButtonEdit', 'TFWEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBTextEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinSelectDirectoryDialog', 'TJvSelectDirectory', [rfReplaceAll,rfIgnoreCase]);
          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinStdLabel', 'TFWLabel', [rfReplaceAll,rfIgnoreCase]);
          ls_Lignes := StringReplace ( ls_Lignes, 'TspSkinPanel', 'TPanel', [rfReplaceAll,rfIgnoreCase]);
          ls_Lignes := StringReplace ( ls_Lignes, 'TFlatPanel', 'TPanel', [rfReplaceAll,rfIgnoreCase]);
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxTabControl', 'TTabControl', [rfReplaceAll] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TEditStyleController', 'TJvSelectDirectory', [rfReplaceAll,rfIgnoreCase]);

          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBLookupEdit', 'TExtDBComboInsert', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBGraphicEdit', 'TDBChart', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBImageEdit', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBImage', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxListBox', 'TDBListBox', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBMemo', 'TFWDBMemo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBLookupEdit', 'TExtDBComboInsert', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxProgressBar', 'TFlatGauge', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBGraphicEdit', 'TDBChart', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBImageEdit', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBImage', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBMemo', 'TFWDBMemo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCheckEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TDBAdvNavigator', 'TExtDBNavigator', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TCxDBNavigator', 'TExtDBNavigator', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbFirst', 'nbEFirst', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbPost' , 'nbEPost', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbLast' , 'nbELast', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbPrior', 'nbEPrior', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbNext', 'nbENext', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbEdit', 'nbEEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbInsert', 'nbEInsert', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbDelete', 'nbEDelete', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbCancel', 'nbECancel', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbRefresh', 'nbERefresh', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbSetBookmark', 'nbEMovePrior', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbGotoBookmark', 'nbEMoveNext', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'nbSearch', 'nbESearch', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Ancestrologie', 'FreeLogy', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxComponentPrinter', 'TPrinterSetupDialog', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxComponentPrinter', 'TPrinterSetupDialog', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBChart', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBChart', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxOrgChart', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxOrgChart', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBGrid', 'TExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxGrid', 'TExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxTextEdit', 'TMaskEdit', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TdxSpinEdit', 'TFWSpinEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxSpinEdit', 'TFWSpinEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxComponentPrinter', 'TPrintSet', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TdxTreeView', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxTreeView', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxTreeView,', 'virtualtrees,virtualdbtreeex,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TGoodBtn', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TNakedSpeedButton', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxTreeList', 'TDBCheckVirtualDBTreeEx', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBTreeViewNode', 'PVirtualNode', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBTreeViewColumn', 'TVirtualHeader', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxOcNode', 'PVirtualNode', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxColorComboBox', 'TExtColorCombo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TColorPickerButton', 'TExtColorCombo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TEMailLabel', 'TOvcURL', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxButtons,', 'u_buttons_appli,JvXPButtons,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDefaulTJvSelectDirectory', 'TSelectDirectoryDialog', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxImage', 'TExtImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxMaskEdit', 'TMaskEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TAnimate', 'TPasLibVlcPlayer', [rfReplaceAll,rfIgnoreCase] );


          if pos ( '{$R *.lfm}', ls_Lignes ) = 0 Then
            ls_Lignes := StringReplace ( ls_Lignes, '{$R *.DFM}', '{$IFDEF FPC}{$R *.lfm}{$ELSE}{$R *.DFM}{$ENDIF}', [rfIgnoreCase] );

          // A enlever : erreur
          ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBTreeColumn', 'TJvExHeaderControl', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TdxEdit', 'TFWEdit', [rfReplaceAll,rfIgnoreCase] );
          if ( pos ( 'Color', ls_Lignes )> 0 ) then
            ls_Lignes := StringReplace ( ls_Lignes, 'TdxButtonEdit', 'TJvColorButton', [rfReplaceAll,rfIgnoreCase] )
            else
              if ( pos ( 'Dir', ls_Lignes )> 0 ) then
                ls_Lignes := StringReplace ( ls_Lignes, 'TdxButtonEdit', 'TDirectoryEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxButtonEdit', 'TJvFontEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxPickEdit', 'TJvMaskEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'PreviewOptions.Caption', 'Title', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxCheckEdit', 'TDBCheckBox', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TGlobe4', 'TCADCmp2D', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxBarButton', 'TMenuItem', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxBarManager', 'TMenu', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxBarSubItem', 'TMenuItem', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TPrintReport', 'TRLPreview', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TPrinterReport', 'TRLPreview', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppPreview', 'TRLPreview', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBPickEdit', 'TExtDBComboInsert', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBTimeEdit', 'TRxDBDateTimePicker', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxDBDateEdit', 'TRxDBDateEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppReport', 'TRLReport', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppDesigner', 'TRLReport', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppSubReport', 'TRLReport', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppChildReport', 'TRLReport', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppHeaderBand', 'TRLBand', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppTitleBand', 'TRLBand', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppSummaryBand', 'TRLBand', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppViewer', 'TRLPreview', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppDBText', 'TRLDBText', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppDBMemo', 'TRLDBMemo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppSubDetail', 'TRLSubDetail', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppDBImage', 'TRLDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppSystemVariable', 'TRLSystemInfo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppGroup', 'TRLGroup', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'URLLink,', '', [rfReplaceAll] );

          ls_Lignes := StringReplace ( ls_Lignes, 'TppLabel', 'TRLLabel', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppDetailBand', 'TRLSubDetail', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppFooterBand', 'TRLBand', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppGraphicEdit', 'TExtDBImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TppShape', 'TRLImage', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxPageControl', 'TPageControl', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxPageControl', 'TPageControl', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxMemo', 'TMemo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxSplitter', 'TSplitter', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxTabSheet', 'TTabSheet', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxLookupComboBox', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxGroupBox', 'TGroupBox', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxRadioButton', 'TRadioButton', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxRadioGroup', 'TRadioGroup', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxShellTreeview', 'TShellTreeView', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxRichEdit', 'TlzRichEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TRichEdit', 'TlzRichEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TJvXPButtonEdit', 'TFWEdit', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'cxGrid,', 'U_ExtDBGrid,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCustomGridTableView', 'TObject', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCanvas', 'TCanvas', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'CustomDrawCell', 'DrawColumnCell', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBLookupComboBox', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBTimeEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBComboBox', 'TFWDBComboBox', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCustomTabControl', 'TCustomTabControl', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxTab', 'TTabSheet', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TExtDBGridTableDataCellViewInfo', 'Longint', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCustomGridRecord', 'Longint', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxGraphics,', 'U_ExtImage,', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCustomGridTableItem', 'Longint', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxCustomEdit', 'TCustomMaskEdit', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TExtImageList', 'TImageList', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TDBCheckVirtualDBTreeExNode', 'PVirtualNode', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TDBCheckVirtualDBTreeExEditCellViewInfo', 'TVTPaintInfo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TDBCheckVirtualDBTreeExColumn', 'TColumnIndex', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.Items', 'Items', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.Images', 'Images', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'ppReport,', 'RLReport,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'dxPrnPg,', 'PrintersDlgs,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxDBEdit,', 'u_framework_dbcomponents,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'dxBar,', 'Menus,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxDBData,', 'U_ExtDBImage,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'cxGrid;', 'U_ExtDBGrid;', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'ppViewr,', 'RLPreview,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'ppDB,', 'RLPreview,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'ppViewr,', 'RLPreview,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Rprinter,', 'RLprinters,', [rfIgnoreCase] );



          ls_Lignes := StringReplace ( ls_Lignes, 'cxTreeView,', 'virtualtrees,virtualdbtreeex,', [rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TcxDBHyperLinkEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );

          ls_Lignes := StringReplace ( ls_Lignes, 'DataBinding.DataField', 'FieldName', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'DataController.DataSource', 'DataSource', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.ReadOnly', 'ReadOnly', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.MinWidth', 'MinWidth', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.MaxWidth', 'MaxWidth', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TExtDBImageComboBox', 'TExtDBPictCombo', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'OnCellDblClick', 'OnDblClick', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'BeforeCellPaint', 'OnGetCellParams', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TdxBar', 'TToolBar', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.Alignment.Horz', 'Alignment', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'Properties.MaxLength', 'MaxLength', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TRLGroupHeaderBand', 'TRLBand', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'TReportPrinter', 'TRLPrinterWrapper', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'DropDownMenu', 'PopupMenu', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace ( ls_Lignes, 'RecordCount=0', 'IsEmpty', [rfIgnoreCase,rfReplaceAll] );
          ls_Lignes := StringReplace ( ls_Lignes, 'RecordCount= 0', 'IsEmpty', [rfIgnoreCase,rfReplaceAll] );
          ls_Lignes := StringReplace ( ls_Lignes, 'RecordCount = 0', 'IsEmpty', [rfIgnoreCase,rfReplaceAll] );
          ls_Lignes := StringReplace ( ls_Lignes, 'RecordCount <> 0', 'not IsEmpty', [rfIgnoreCase,rfReplaceAll] );
          ls_Lignes := StringReplace ( ls_Lignes, 'RecordCount<> 0', 'not IsEmpty', [rfIgnoreCase,rfReplaceAll] );
          ls_Lignes := StringReplace ( ls_Lignes, 'RecordCount<>0', 'not IsEmpty', [rfIgnoreCase,rfReplaceAll] );

          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'DirExists','DirectoryExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileExists','FileExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileExistsUTF8UTF8','FileExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'TStringlist','TStringlistUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'TStringlistUTF8UTF8','TStringlistUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'DirectoryExists','DirectoryExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'DirectoryExistsUTF8UTF8','DirectoryExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileExists','FileExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileExistsUTF8UTF8','FileExistsUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FindFirst','FindFirstUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FindFirstUTF8UTF8','FindFirstUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FindClose','FindCloseUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FindCloseUTF8UTF8','FindCloseUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileOpen','FileOpenUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileOpenUTF8UTF8','FileOpenUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FindNext','FindNextUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FindNextUTF8UTF8','FindNextUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'RemoveDir','RemoveDirUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'RemoveDirUTF8UTF8','RemoveDirUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'CreateDir','CreateDirUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'CreateDirUTF8UTF8','CreateDirUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'DeleteFile','DeleteFileUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'DeleteFileUTF8UTF8','DeleteFileUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileCreate','FileCreateUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'FileCreateUTF8UTF8','FileCreateUTF8',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'CreateDirUTF8ectory','CreateDirectory',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'TStringlistUTF8Array','TStringlistArray',[rfReplaceAll,rfIgnoreCase]);
          lst_Lignes.Text:=StringReplace(lst_Lignes.text,'NextUTF8Control','NextControl',[rfReplaceAll,rfIgnoreCase]);


          ls_Lignes := StringReplace ( ls_Lignes, 'GetObjectPropClass(self,PropInfo)', 'GetObjectPropClass(self,{$IFDEF FPC}s{$ELSE}PropInfo{$ENDIF})', [rfReplaceAll,rfIgnoreCase] );
          ls_Lignes := StringReplace( ls_Lignes,'u_comp_TJvXPButton, ','',[rfReplaceAll,rfIgnoreCase]);

//      ls_Lignes := StringReplace ( ls_Lignes, 'TcxDefaulTJvSelectDirectory', 'TDirectoryEdit', [rfReplaceAll,rfIgnoreCase] );
        end;


      lst_Lignes.Text := ls_Lignes ;
     if lb_DFM
     or lb_LFM Then
       ConvertitLigneDFM ( lst_Lignes, FilePath )
      else
       ConvertitLignePAS ( lst_Lignes, FilePath );

    Application.ProcessMessages;
  finally
    lst_Lignes.EndUpdate;
    if lb_dfm then
      Begin
        lst_Lignes.SaveToFile   ( FilePath );
       // if not FileExists(copy ( FilePath, 1, length ( filepath ) - 3 ) + 'lfm') Then
          Begin
            p_setLignes ( lst_Lignes, FilePath );
          end;
      End
    Else
      Begin
        lst_Lignes.SaveToFile   ( FilePath );
      End ;


    lst_Lignes.Free;
    Messages.Lines.Add ( '  - Fichier ' + FileName + ' converti...' );
  end;

end;

function fb_IsField ( const as_ligne : String ) : Boolean;
Begin
  Result :=
       ( pos ( 'TIBStringField', as_Ligne )> 0 )
    or ( pos ( 'TIBBlobField', as_Ligne )> 0 )
    or ( pos ( 'TIBIntegerField', as_Ligne )> 0 )
    or ( pos ( 'TIBDateTimeField', as_Ligne )> 0 )
    or ( pos ( 'TIBFloatField', as_Ligne )> 0 )
    or ( pos ( 'TBlobField', as_Ligne )> 0 )
    or ( pos ( 'TFMTBCDField', as_Ligne )> 0 )
    or ( pos ( 'TDateTimeField', as_Ligne )> 0 )
    or ( pos ( 'TTimeField', as_Ligne )> 0 )
    or ( pos ( 'TDateField', as_Ligne )> 0 )
    or ( pos ( ':TIdHTTP', as_Ligne )> 0 )
    or ( pos ( ': TIdAntiFreeze', as_Ligne )> 0 )
    or ( pos ( ':TIdEncoderMIME', as_Ligne )> 0 )
    or ( pos ( 'TIntegerField', as_Ligne )> 0 )
    or ( pos ( 'TStringField', as_Ligne )> 0 )
    or ( pos ( 'TFloatField', as_Ligne )> 0 )
    or ( pos ( 'oemto', LowerCase( as_Ligne ) )> 0 )
    or ( pos ( 'tooem', LowerCase( as_Ligne ))> 0 )
    or ( pos ( 'TMemoField', as_Ligne )> 0 );
End;


function fb_posUnwanted ( const as_Begin, as_ligne : String ; const ab_Grid : Boolean ) : Boolean ;
Begin
  Result := ( pos ( as_Begin + 'TExtDBGridBandedTableViewStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridTableViewStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxCustomContainerReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxCustomContainerReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtraOptions', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TRLDetailGrid', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntlPrintSys3', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntlBars', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntl', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExColumn', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridLevel', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxEditStyleController', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TWizardTree', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxHintStyleController', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxPrintStyleManager', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TBasedxPrintStyle', as_ligne )> 0 )
         or ( pos ( as_Begin + ' TppDBPipeline', as_ligne )> 0 )

         or ( pos ( as_Begin + 'TcxStyle', as_ligne )> 0 );
  if not Result
  and ab_Grid Then
  Result := ( pos ( as_Begin + 'TExtDBGridDBColumn', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBBandedTableView', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBTableView', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TColumnIndex', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBBandedColumn ', as_ligne )> 0 );

end;


procedure TForm1.ConvertitLignePAS( var ast_Lignes : TStringList; as_Lignes : String );
var li_pos1 : LongInt;
    ls_Ligne, ls_ligneLower : String;
    lb_delphi, lb_interface, lb_implementation, lb_uses1, lb_uses2, lb_usesend1, lb_usesend2 : Boolean ;

    procedure p_DeleteUnits ( const as_unitbegin : string );
    var li_pos2, li_pos3 : LongInt;
    Begin
      li_pos2:=1;
      while ( posex ( as_unitbegin, ls_ligneLower, li_pos2 ) > 0 ) do
        Begin
          li_pos2:= posex ( as_unitbegin, ls_ligneLower, li_pos2 );
          if ( li_pos2 = 1 )
          or ( ls_ligneLower [ li_pos2 - 1 ] in [' ', ','] )
           then
            Begin
              li_pos3:= PosEx( ',', ls_Ligne, li_pos2 );
              if li_pos3 = 0 then
                Begin
                  while ( li_pos2 > 0 ) and ( ls_ligneLower [ li_pos2 ] <> ',' ) do
                    dec ( li_pos2 );
                  if li_pos2 = 0 Then
                    ls_Ligne := '';
                  ls_Ligne:=copy ( ls_Ligne, 1, li_pos2 -1 );
                  ls_ligneLower:=copy ( ls_ligneLower, 1, li_pos2 - 1 );
                end
              else
                Begin
                  ls_Ligne:=copy ( ls_Ligne, 1, li_pos2 -1 ) + copy ( ls_ligne, li_pos3 + 1, length ( ls_ligneLower ) - li_pos3 );
                  ls_ligneLower:=copy ( ls_ligneLower, 1, li_pos2 - 1 ) + copy ( ls_ligneLower, li_pos3 + 1, length ( ls_ligneLower ) - li_pos3 );
                end;
            end
          else inc ( li_pos2 );
        end;
    End;
    function fb_DeleteCXDX ( var ab_uses : boolean ):Boolean;
    var li_pos2 : LongInt;
    Begin
      Result := False;
      if not ab_uses Then
        ab_uses:=     ( pos ( 'uses', ls_ligneLower ) > 0)
                  and ( pos ( 'uses', ls_ligneLower ) < 3);
      if ab_uses then
        Begin
          Result := pos ( ';', ls_ligne )>0;
          p_DeleteUnits ( 'cx' );
          p_DeleteUnits ( 'dx' );
          ast_Lignes.EndUpdate;
          while trim (ls_ligne) = '' do
            begin
              ast_Lignes.Delete(li_pos1);
              dec ( li_pos1 );
              ls_Ligne:= ast_Lignes [ li_pos1 ];
            end;
          ast_Lignes.BeginUpdate;
          if Result and (pos ( ';', ls_ligne )=0)
            then
             Begin
               ls_ligneLower:= LowerCase(ls_Ligne);
               li_pos2:=Length(ls_Ligne);
               while ( li_pos2 > 1 )
               and not ( ls_ligneLower [ li_pos2 ] in [ 'a'..'z' ]) do
                 Begin
                   if ls_ligne [ li_pos2 ] = ',' then
                    Begin
                     ls_ligne [ li_pos2 ] := ';';
                     Exit;
                    end;
                   dec ( li_pos2 );
                 end;
               AppendStr(ls_Ligne,';');
             end;
        end;
    end;

begin
  li_pos1 := -1;
  lb_delphi := False;
  lb_interface := False ;
  lb_implementation  := False ;
  lb_uses1  := False ;
  lb_uses2  := False ;
  lb_usesend1  := False ;
  lb_usesend2  := False ;
  ast_Lignes.BeginUpdate;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      if not lb_implementation
      and fb_posUnwanted ( ':', ls_Ligne, True ) Then
       Begin
        ast_Lignes.EndUpdate;
        repeat
          ast_Lignes.Delete(li_pos1);
          ls_Ligne := ast_Lignes [ li_pos1 ];
        until not fb_posUnwanted ( ':', ls_Ligne, True );
        ast_Lignes.BeginUpdate;
       end;

      ls_ligneLower := LowerCase(ls_ligne);

      if  lb_interface
      and not lb_usesend1 Then
        lb_usesend1:= fb_DeleteCXDX(lb_uses1);

      if  lb_implementation
      and not lb_usesend2 Then
        lb_usesend2:= fb_DeleteCXDX(lb_uses2);

      if lb_implementation
      and not lb_usesend2 Then
        lb_usesend2 := pos ( 'begin', ls_ligneLower ) = 1;

      if lb_interface
      and not lb_usesend1 Then
        lb_usesend1 := ( pos ( 'type', ls_ligneLower ) = 1 ) or ( pos ( 'function', ls_ligneLower ) = 1 ) or ( pos ( 'procedure', ls_ligneLower ) = 1 );


      if not lb_interface Then
       lb_interface := ( pos ( 'interface', ls_ligneLower ) = 1 ) or ( pos ( 'type', ls_ligneLower ) = 1 ) or ( pos ( 'function', ls_ligneLower ) = 1 ) or ( pos ( 'procedure', ls_ligneLower ) = 1 );

      if not lb_implementation Then
        lb_implementation := ( pos ( 'implementation', ls_ligneLower ) = 1 ) or ( pos ( 'begin', ls_ligneLower ) = 1 );
      if not lb_implementation
      and fb_IsField ( ls_ligne )
      and (( pos ( 'procedure', ls_Ligne )= 0 ) and ( pos ( 'function', ls_Ligne )= 0 ))
       Then
       Begin
         if not lb_delphi
         and not gb_Posifndef_fpc Then
           Begin
             ast_Lignes.Insert(li_pos1, '{$IFNDEF FPC}');
             inc(li_pos1);
             lb_delphi := True;
           end;
       end
      else
      Begin
        if lb_delphi Then
          Begin
            ast_Lignes.Insert(li_pos1, '{$ENDIF}');
            inc(li_pos1);
            lb_delphi := False;
          end;
      end;

      if ( pos ( 'query', LowerCase( ls_Ligne ) )> 0 ) Then
       Begin
         ConvertitField( ls_Ligne, pos ( 'query', LowerCase( ls_Ligne )) + 5 );
       end;
      if ( pos ( 'ibq', LowerCase( ls_Ligne ))> 0 ) Then
       Begin
         ConvertitField( ls_Ligne, pos ( 'ibq', LowerCase( ls_Ligne )) + 3 );
       end
      else if ( pos ( 'IB', ls_Ligne )> 0 ) Then
       Begin
         ConvertitField( ls_Ligne, pos ( 'IB', ls_Ligne ) + 2 );
       end;
      ConvertitLigneDFMPAS ( ls_ligne );
      ast_Lignes [ li_pos1 ] := ls_Ligne;

    End;
end;

procedure TForm1.ConvertitLigneDFM( var ast_Lignes : TStringList; as_Lignes : String );
var li_pos1, li_pos2, li_pos3, li_pos4, li_pos5, li_pos6 : LongInt;
    ls_Ligne, ls_temp : String;
    lb_columns, lb_lookup, lb_end, lb_tree, lb_grid, lb_double : Boolean;

function fb_IsGridColumn ( const as_ligne : String ) : Boolean ;
begin
  Result := ( pos ( 'TExtDBGridDBColumn', as_Ligne  ) > 0 )
            or ( pos ( 'TDBCheckVirtualDBTreeExColumn', as_Ligne  ) > 0 )
            or ( pos ( 'TColumnIndex', as_Ligne  ) > 0 )
            or ( pos ( 'TExtDBGridDBBandedColumn', as_Ligne ) > 0 );
end;

function fb_deleteOtherItem : Boolean;
begin
  if ( pos ( '<', ls_ligne ) > 0 ) Then
   Begin
    repeat
     ls_ligne := ast_Lignes [ li_pos1 ];
     ast_Lignes.delete ( li_pos1 );
    until pos ( '>', ls_ligne ) > 0;
    Result := True;
    dec ( li_pos1 );
    Exit;
   end;
  Result := False;

end;

begin
  li_pos1 := -1;
  li_pos2 := -1;
  li_pos3 := -1;
  li_pos4 := -1;
  lb_columns := False;
  lb_lookup  := False;
  lb_end := True;
  lb_tree := False ;
  lb_double := False ;
  lb_grid:=False;
  ast_Lignes.BeginUpdate;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      if fb_posUnwanted ( '', ls_Ligne, False )
       Then
        Begin
          ast_Lignes.EndUpdate;
          DeleteUntilEnd(ast_Lignes,li_pos1, pos ( 'object', ls_Ligne ));
          ast_Lignes.BeginUpdate;
          dec ( li_pos1 );
          Continue;
        end;
      if not lb_lookup
      and not lb_grid
      and not lb_tree then
        Begin
          lb_grid := pos ( 'TExtDBGrid', ls_Ligne ) > 0;
          li_pos2 := pos ( 'object', ls_Ligne );
          lb_tree := False ;
          lb_double := False ;
          if  not lb_grid then
            Begin
              lb_tree := pos ( 'TDBCheckVirtualDBTreeEx', ls_Ligne ) > 0;
              li_pos2 := pos ( 'object', ls_Ligne );
              lb_grid:=False;
              lb_double := False ;
            End;
        End;
      if not lb_columns
      and ( lb_grid or lb_tree ) Then
        Begin
          li_pos4 := pos ( 'TExtDBGridDBTableView', ls_Ligne );
          if li_pos4 = 0 Then
            li_pos4 := pos ( 'TColumnIndex', ls_Ligne );
          if li_pos4 = 0 Then
            li_pos4 := pos ( 'TExtDBGridDBBandedTableView', ls_Ligne  ) ;

          if li_pos4 > 0 then
           begin
            lb_double := True ;
            li_pos2 := pos ( 'object', ls_Ligne );
            ast_Lignes.Delete(li_pos1);
            dec ( li_pos1 );
            while not fb_IsGridColumn ( ls_Ligne ) do
                begin
                  inc ( li_pos1 );
                  ls_Ligne:=ast_Lignes [ li_pos1 ];
                  if fb_deleteOtherItem Then
                    Continue;
                  if ( pos ( 'end', ls_Ligne ) > 0 ) Then
                   Begin
                    ast_Lignes.Delete(li_pos1);
                    dec ( li_pos1 );
                    Break;
                   end;
                end;
            ls_Ligne:=ast_Lignes [ li_pos1 ];
           end;
          if ( lb_double )
          and ( pos ( 'end', ls_Ligne ) = li_pos2 ) Then
            Begin
              li_pos3 := li_pos2 - 2 ;
              if lb_tree Then
                begin
                  ast_Lignes [ li_pos1 ] := '              Header.Columns = <';
                end
              Else
                ast_Lignes [ li_pos1 ] := '              Columns = <';
              lb_tree:=True;
              lb_columns := True;
              lb_end := True;
              inc(li_pos1);
              ast_Lignes.Insert(li_pos1,'              item');
            End
         else if (  fb_IsGridColumn (ls_Ligne ) ) Then
           Begin
              li_pos3 := pos ( 'object', ls_Ligne  );
              if lb_tree Then
                ast_Lignes [ li_pos1 ] := '              Header.Columns = <'
              Else
                ast_Lignes [ li_pos1 ] := '              Columns = <';
              lb_tree:=False;
              lb_columns := True;
              lb_end := True;
              inc(li_pos1);
              ast_Lignes.Insert(li_pos1,'              item');
              li_pos2:=li_pos3;
            end;
         if ( not lb_double )
         and ( pos ( 'end', ls_Ligne ) = li_pos2 ) Then
           begin
            lb_tree:=False;
            lb_grid:=False;
           end;
         Continue;
        End;

      if lb_columns then
        begin
          if ( pos ( 'Properties.', ls_Ligne ) > 0 )
          or ( pos ( 'Options.', ls_Ligne ) > 0 )
          or ( pos ( 'Styles.', ls_Ligne ) > 0 )
          or ( pos ( 'Position.', ls_Ligne ) > 0 )
          or ( pos ( 'Styles.', ls_Ligne ) > 0 )
          or ( pos ( 'PropertiesClassName', ls_Ligne ) > 0 )
           Then
            Begin
             ast_Lignes.Delete(li_pos1);
             dec (li_pos1 );
             Continue;
            end;
          if fb_deleteOtherItem Then
            Continue;
          li_pos4 := pos ( 'end', ls_Ligne );
          if fb_IsGridColumn ( ls_ligne )
           Then
            Begin
              if pos ( 'item', ast_Lignes [ li_pos1 - 1 ]) > 0 Then
                Begin
                  ast_Lignes.Delete ( li_pos1 );
                  dec ( li_pos1 );
                  Continue;
                end;
              ast_Lignes [ li_pos1 ] := '              item';
              ast_Lignes.Insert ( li_pos1, '              end');
              inc ( li_pos1 );
              Continue;
            End;
          if  ( li_pos4 > 0 ) Then
           Begin
             if  lb_double
             and ( li_pos4 = li_pos2 )
              then
               Begin
                 if ( pos ( 'end', ast_Lignes [ li_pos1 + 1 ] ) > 0 ) then
                   if lb_tree Then
                     Continue
                    Else
                     ast_Lignes [ li_pos1 + 1 ] := StringReplace ( ast_Lignes [ li_pos1 + 1 ], 'end', 'end>', [] );
                 ast_Lignes.EndUpdate;
                 ast_Lignes.delete ( li_pos1 );
                 ast_Lignes.BeginUpdate;
                 lb_end := False;
                 dec ( li_pos1, 2 );
                 Continue;
               End;
             if  ( li_pos4 < li_pos2 ) then
               Begin
                 if ( lb_tree )
                 and ( pos ( 'end', ast_Lignes [ li_pos1 - 1 ] ) > 0 )
                  then
                   Begin
                     ast_Lignes [ li_pos1 - 1 ] := StringReplace ( ast_Lignes [ li_pos1 - 1 ], 'end', 'end>', [] );
                   End;
                 lb_columns := False;
                 lb_tree    := False;
                 lb_grid    := False;
                 Continue;
               End;
            if ( li_pos4 = li_pos3 ) Then

             begin
              if pos ( 'TExtDBGridDBBandedTableView', ast_Lignes [ li_pos1 + 2 ] ) > 0 Then
                repeat
                  ast_Lignes.delete ( li_pos1 + 1 ) ;
                until (    fb_IsGridColumn ( ast_Lignes [ li_pos1 + 1 ] )
                      or (     ( pos ( ' end', ast_Lignes [ li_pos1 + 1 ] ) > 0 )
                           and ( pos ( 'end', ast_Lignes [ li_pos1 + 1 ] ) <= li_pos3 )));
              if not fb_IsGridColumn ( ast_Lignes [ li_pos1 + 1 ] )
               then
                Begin
                  ast_Lignes [ li_pos1 ] := StringReplace ( ls_Ligne, 'end', 'end>', [] );
                  Continue;
                End;

             end;
           end;
          if pos ( 'FieldName', ls_Ligne )> 0 then
            ls_Ligne := StringReplace( ls_Ligne, 'DataBinding.', '', [] )
          else if pos ( 'Caption', ls_Ligne )> 0 then
            ls_Ligne := StringReplace( ls_Ligne, 'Caption', 'Title.Caption', [] )
          else if pos ( 'Width', ls_Ligne )= 0 then
            Continue;
        end;
      if not lb_lookup
      and not lb_columns Then
        Begin
          li_pos2 := pos ( 'Properties.ListColumns', ast_Lignes [ li_pos1 ] );
          if li_pos2 <> 0 then
            Begin
              inc ( li_pos2, 2 );
              ls_Ligne := '  LookupDisplay = ''';
              while ( pos ( 'end>', ast_Lignes [ li_pos1 ] ) <> li_pos2 ) do
                Begin
                  if pos ( 'FieldName', ast_Lignes [ li_pos1 ] ) <> 0 Then
                    ls_Ligne := ls_Ligne + Copy ( ast_Lignes [ li_pos1 ], pos ( '''', ast_Lignes [ li_pos1 ]) + 1 , posex ( '''', ast_Lignes [ li_pos1 ], pos ( '''', ast_Lignes [ li_pos1 ]) + 1) - li_pos1 - 1 )  + ',';
                  ast_Lignes.Delete(li_pos1);
                End;
              ls_Ligne [ Length(ls_Ligne)] := '''';
              ast_Lignes [ li_pos1 ] := ls_Ligne;
              Continue;
            End;

        End;
       if ( pos ( 'Items', ls_Ligne )> 0 )
       and ( pos ( '>', ls_Ligne )> 0 )
       Then
       Begin
         ast_Lignes.EndUpdate;
         repeat
           ls_Ligne := ast_Lignes [ li_pos1 ];
           ast_Lignes.Delete(li_pos1);
         until pos ( 'end>', ls_Ligne ) > 0;
         dec ( li_pos1 );
         ast_Lignes.BeginUpdate;
         Continue;
       end;
       if ( pos ( 'PreviewOptions.PreviewBoundsRect', ls_Ligne )> 0 )
       or ( pos ( 'PreviewOptions.WindowState', ls_Ligne )> 0 )
       Then
       Begin
         ast_Lignes.EndUpdate;
         ast_Lignes.Delete(li_pos1);
         dec ( li_pos1 );
         ast_Lignes.BeginUpdate;
         Continue;
       end;
       if ( pos ( 'mmHeight', ls_ligne ) > 0 )
       or ( pos ( 'mmTop'   , ls_ligne ) > 0 )
       or ( pos ( 'mmWidth' , ls_ligne ) > 0 )
       or ( pos ( 'mmLeft'  , ls_ligne ) > 0 ) Then
         begin
           ls_Ligne := StringReplace( ls_Ligne, 'mm', '', [rfIgnoreCase] );
           ls_temp := copy ( ls_Ligne, pos ( '= ', ls_ligne ) + 2, length ( ls_ligne ) - pos ( '= ', ls_ligne ) - 1 );
           if length ( ls_temp ) > 3 Then
             ls_Ligne := copy ( ls_Ligne, 1, length ( ls_ligne ) - 3 )
           else if length ( ls_temp ) > 2 Then
             ls_Ligne := copy ( ls_Ligne, 1, length ( ls_ligne ) - 2 )
           else if length ( ls_temp ) > 1 Then
             ls_Ligne := copy ( ls_Ligne, 1, length ( ls_ligne ) - 1 );
         end;
      if pos ( 'DataPipeline', ls_ligne ) > 0 Then
        begin
          ls_temp := copy ( ls_Ligne, pos ( '= ', ls_ligne ) + 2, length ( ls_ligne ) - pos ( '= ', ls_ligne ) - 1 ) + ':';
          for li_pos5 := ast_Lignes.count -1 downto 0 do
            if  ( pos ( ls_temp, ast_Lignes [ li_pos5 ])>0 )
            and ( pos ( 'object', ast_Lignes [ li_pos5 ])>0 ) Then
              begin
                for li_pos6  := li_pos5 + 1 to ast_Lignes.count -1 do
                  if ( pos ( 'DataSource', ast_Lignes [ li_pos6 ] ) > 0 ) Then
                    Begin
                      ast_Lignes [ li_pos1 ] := ast_Lignes [ li_pos6 ];
                      Break;
                    end;
                Break;
              end;
          Continue;
        end;
      ConvertitLigneDFMPAS ( ls_ligne );
      ast_Lignes [ li_pos1 ] := ls_Ligne;

    End;
end;

procedure TForm1.DeleteUntilEnd( const ast_Lignes : TStringList ; const ai_pos1, ai_posEnd : LongInt );
var ls_Ligne : String;
Begin
  repeat
  ls_Ligne := ast_Lignes [ ai_pos1 ];
  ast_Lignes.Delete( ai_pos1);
  until ( pos ( 'end', ls_Ligne ) > 0 )
    and (( ai_posEnd = -1 ) or ( ai_posEnd = pos ( 'end', ls_Ligne )));
end;

procedure TForm1.ConvertitLigneLFM( const ast_Lignes : TStringList );
var li_pos1 : LongInt;
    ls_Ligne : String;

begin
  li_pos1 := -1;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      if fb_IsField ( ls_Ligne )
       Then
       Begin
         DeleteUntilEnd(ast_Lignes, li_pos1, pos ( 'object', ls_Ligne ));
         dec ( li_pos1 );
         Continue;
       end;

    End;
end;

end.
